package com.dartmaker.uponevent;

import android.content.Intent;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;

public class LoginActivity extends AppCompatActivity {

    private EditText loginEmail;
    private EditText loginPass;
    private FirebaseAuth mAuth;
    private DatabaseReference mDatabase;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        //INICIALITZEM LES VARIABLES
        loginEmail = findViewById(R.id.loginEmail);
        loginPass = findViewById(R.id.loginPass);

        //INICIALITZEM LES REFERENCIES PRINCIPALS
        mAuth = FirebaseAuth.getInstance();
        mDatabase = FirebaseDatabase.getInstance().getReference().child("Users");

    }

    public void loginButtonClicked(View view){
        String email = loginEmail.getText().toString().trim();
        String pass = loginPass.getText().toString().trim();

        if(!TextUtils.isEmpty(email) && !TextUtils.isEmpty(pass)){
            mAuth.signInWithEmailAndPassword(email, pass)
                    .addOnCompleteListener(LoginActivity.this, new OnCompleteListener<AuthResult>() {
                        @Override
                        public void onComplete(@NonNull Task<AuthResult> task) {
                            if (task.isSuccessful()) {
                                //EL LOGIN HA SIGUT SATISFACTORI, HO MOSTREM PER TOAST I SALTEM A MAINACTIVITY
                                FirebaseUser user = mAuth.getCurrentUser();
                                Toast.makeText(LoginActivity.this, getResources().getString(R.string.Login_success), Toast.LENGTH_SHORT).show();

                                String user_id = user.getUid();
                                Intent mainIntent = new Intent(LoginActivity.this, MainActivity.class);
                                startActivity(mainIntent);

                            } else {
                                //LOGIN INCORRECTE, HO MOSTREM PER TOAST
                                Toast.makeText(LoginActivity.this, getResources().getString(R.string.Login_failed), Toast.LENGTH_SHORT).show();
                            }
                        }
                    });


        }
    }

    //FUNCIO PER SALTAR A ACTIVITY DE REGISTRE
    public void signUpButtonClicked(View view){
        Intent signUpIntent = new Intent(LoginActivity.this, RegisterActivity.class);
        startActivity(signUpIntent);
        finish();
    }


}
