package com.dartmaker.uponevent;

import android.content.Context;
import android.content.Intent;
import android.support.annotation.NonNull;
import android.support.design.widget.BottomNavigationView;
import android.support.design.widget.TabLayout;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.text.TextUtils;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.squareup.picasso.Picasso;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

public class SearchActivity extends AppCompatActivity  {

    protected DatabaseReference mDatabase_events;
    protected Query mQuery;
    protected BottomNavigationView bottomNavigation;
    protected FirebaseAuth mAuth;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search);

        //INICIALITZEM LES VARIABLES
        bottomNavigation = findViewById(R.id.search_bottom_navigation);

        //INICIALITZEM LES REFERENCIES PRINCIPALS
        mDatabase_events = FirebaseDatabase.getInstance().getReference().child("Events");
        mAuth = FirebaseAuth.getInstance();


        TabLayout tabLayout = (TabLayout) findViewById(R.id.tab_layout);
        tabLayout.addTab(tabLayout.newTab().setText(getResources().getString(R.string.Events)));
        tabLayout.addTab(tabLayout.newTab().setText(getResources().getString(R.string.Users)));
        tabLayout.setTabGravity(TabLayout.GRAVITY_FILL);

        final ViewPager viewPager = (ViewPager) findViewById(R.id.pager);
        final PagerAdapter adapter = new PagerAdapter(getSupportFragmentManager(), tabLayout.getTabCount());

        viewPager.setAdapter(adapter);
        viewPager.addOnPageChangeListener(new TabLayout.TabLayoutOnPageChangeListener(tabLayout));
        tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                viewPager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
    }

    @Override
    protected void onStart(){
        super.onStart();

        //INICIALITZEM EL MENU DE NAVEGACIO HORITZONTAL I AFEGIM ELS LISTENERS
        bottomNavigation.setSelectedItemId(R.id.menuMain_search_item);
        bottomNavigation.setOnNavigationItemSelectedListener(new BottomNavigationView.OnNavigationItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                int id = item.getItemId();

                if(id == R.id.menuMain_home_item){
                    Intent intent = new Intent(SearchActivity.this, MainActivity.class);
                    startActivity(intent);
                    finish();
                }

                else if(id == R.id.addIcon){
                    Intent intent = new Intent(SearchActivity.this, NewEventActivity.class);
                    startActivity(intent);
                    finish();
                }

                else if(id == R.id.menuMain_profile_item){
                    Intent main_viewUser_intent = new Intent(SearchActivity.this, ViewUserActivity.class);
                    main_viewUser_intent.putExtra("user_fireBaseKey", mAuth.getCurrentUser().getUid());
                    startActivity(main_viewUser_intent);
                    finish();
                }

                else if(id == R.id.menuMain_search_item){
                    return true;
                }

                return true;
            }
        });
    }
}
