package com.dartmaker.uponevent;

import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;

import com.firebase.ui.database.FirebaseRecyclerAdapter;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.Query;
import com.squareup.picasso.Picasso;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

public class SearchUserFragment extends Fragment {

    protected EditText searchUser_search_editText;
    protected ImageButton searchUser_searchButton_imageButton;
    protected RecyclerView searchUser_userList_recycler;
    protected DatabaseReference mDatabase_users;
    protected Query mQuery;

    public SearchUserFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment

        View view = inflater.inflate(R.layout.fragment_search_user, container, false);

        //INICIALITZEM LES VARIABLES
        searchUser_search_editText = view.findViewById(R.id.searchUser_search_editText);
        searchUser_searchButton_imageButton = view.findViewById(R.id.searchUser_searchButton_imageButton);
        searchUser_userList_recycler = view.findViewById(R.id.searchUser_userList_recycler);
        searchUser_userList_recycler.setLayoutManager(new LinearLayoutManager(getContext()));
        searchUser_userList_recycler.setHasFixedSize(true);

        //INICIALITZEM LES REFERENCIES PRINCIPALS
        mDatabase_users = FirebaseDatabase.getInstance().getReference().child("Users");

        searchUser_searchButton_imageButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                searchUser_searchButtonClicked();
                ApplicationUtils.hideKeyboard(getContext());
                searchUser_search_editText.clearFocus();
            }
        });

        return view;
    }

    //FILTREM ELS RESULTATS
    public void searchUser_searchButtonClicked(){

        if(!TextUtils.isEmpty(searchUser_search_editText.getText().toString())){
            String searchField = searchUser_search_editText.getText().toString();

            //QUERY DE FILTRATGE
            //mQuery = mDatabase_users.orderByChild("name").equalTo(searchField);
            mQuery = mDatabase_users.orderByChild("name")
                    .startAt(searchField)
                    .endAt(searchField+"\uf8ff");

            //RECUPEREM ELS ESDEVENIMENTS DE LA BASE DE DADES AMB EL MODEL EVENTMODEL SEGONS LA QUERY ANTERIOR I OMPLIM LES VISTES ITEM_EVENT MITJANÇANT LA CLASSE EVENTITEMVIEWHOLDER
            final FirebaseRecyclerAdapter<UserModel, SearchUserFragment.UserItemViewHolder> FBRA = new FirebaseRecyclerAdapter<UserModel, SearchUserFragment.UserItemViewHolder>(UserModel.class, R.layout.item_user_list, SearchUserFragment.UserItemViewHolder.class, mQuery) {
                @Override
                protected void populateViewHolder(final SearchUserFragment.UserItemViewHolder viewHolder, UserModel model, int position) {
                    final String user_fireBaseKey = getRef(position).getKey();
                    viewHolder.setName(model.getName());
                    viewHolder.setUserImage(getContext(), model.getImage());

                    viewHolder.itemView.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            Intent main_viewUser_Intent = new Intent(getActivity(), ViewUserActivity.class);
                            main_viewUser_Intent.putExtra("user_fireBaseKey", user_fireBaseKey);
                            startActivity(main_viewUser_Intent);
                        }
                    });
                }
            };

            searchUser_userList_recycler.setAdapter(FBRA);
        }

    }

    //VIEWHOLDER AUXILIAR PER EMPLENAR ELS LAYOUTS ITEM_EVENT
    public static class UserItemViewHolder extends RecyclerView.ViewHolder{
        public UserItemViewHolder(View itemView){
            super(itemView);
            View mView = itemView;
        }

        public void setName(String name){
            TextView user_name = itemView.findViewById(R.id.itemUserList_userName_textView);
            user_name.setText(name);
        }

        public void setUserImage(Context ctx, String image){
            ImageView user_image = itemView.findViewById(R.id.itemUserList_userImage_imageView);
            Picasso.with(ctx).load(image).into(user_image);
        }
    }

}
